<?php

class Emulator extends Module
{
  var $Id;
  var $Emulator;
  var $Task;
  
  function __construct($Database, $Id)
  {
    $this->Database = $Database;
    $this->Task = new Task($Database);
    $this->Id = $Id;
    $DbResult = $this->Database->query('SELECT * FROM `Emulator` WHERE `Id`='.$Id);
    $this->Emulator = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT * FROM `ClientVersion` WHERE `Id`='.$this->Emulator['ClientVersion']);
    $this->Emulator['ClientVersion'] = $DbResult->fetch_assoc();
  }
  
  function Add()
  {
    $EmulatorDir = '../emulator/'.$this->Id.'/';
    if(!file_exists($EmulatorDir)) mkdir($EmulatorDir, 0777, true);    
    
    //$this->AddTask('Vytvoření nového emulátoru', array(
    //  'ln -s wowclient/'.$this->Emulator['ClientVersion']['Version'].'/maps emulator/'.$this->Emulator['Id'].'/mangos/maps',
    //  'ln -s wowclient/'.$this->Emulator['ClientVersion']['Version'].'/dbc emulator/'.$this->Emulator['Id'].'/mangos/dbc',
    //));
    $this->Download();
    $this->Compile();
  }
  
  function Download()
  {
    global $Config;
    
    $this->Task->Add('Stažení emulátoru', array(
      'cd '.$Config['BaseDir'].'emulator/'.$this->Id.'/',
      'git clone git://github.com/mangos/mangos.git source',
      'cd source',
      'git checkout '.$this->Emulator['CommitHash'],
      'mkdir src/bindings/ScriptDev2',
      'svn checkout -r '.$this->Emulator['ScriptDev2Revision'].' https://scriptdev2.svn.sourceforge.net/svnroot/scriptdev2/ src/bindings/ScriptDev2',
      'git apply src/bindings/ScriptDev2/patches/'.$this->Emulator['ScriptDev2PatchFileName'],
    ));
  }
  
  function Compile()
  {
    global $Config;
    
    $this->Task->Add('Překlad emulátoru', array(
      'cd '.$Config['BaseDir'].'emulator/'.$this->Id.'/source',
      'autoreconf -ifv',
      'mkdir objdir',
      'cd objdir',
      'export CFLAGS="-g -ggdb '.$Config['CompilerParameters'],
      'export CXXFLAGS="-g -ggdb '.$Config['CompilerParameters'],
      '../configure --prefix='.$Config['BaseDir'].'emulator/'.$this->Id.'/ --enable-cli --enable-ra',
      'make',
      'make install',
    ));
  }

  function ExtractMaps()
  {
    $this->Task->Add('Vygenerování souborů map', array(
      'cd wowclient/'.$this->Emulator['ClientVersion']['Version'].'/client',
      'wine emulator/'.$this->Id.'/source/contrib/extractor/ad.exe',
      'mv wowclient/'.$this->Emulator['ClientVersion']['Version'].'/client/dbc wowclient/'.$this->Emulator['ClientVersion']['Version'].'/',
      'mv wowclient/'.$this->Emulator['ClientVersion']['Version'].'/client/maps wowclient/'.$this->Emulator['ClientVersion']['Version'].'/',
    ));
    return('Požadavek na vygenerování map zařazen.');
  }
}

?>
